PROJECT = "GPIO"
VERSION = "1.0.0"

BSP = misc.getType():upper() -- 硬件类型,具体到模组型号,ZL401
HW = rtos.hw():upper() -- 硬件类型,具体到系列型号，ZL400,ZL500

log.info("HW PLAT IS", HW)

-- 定时打印信息
sys.timerLoopStart(function()
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())

    log.info("BSP", BSP)
    log.info("TS", os.time() * 1000)

    if HW == "ZL400" then
        log.info("IMEI", misc.getImei()) -- 模组IMEI
        log.info("ICCID", misc.getIccid()) -- SIM 卡ICCID
        log.info("CSQ", misc.getCsq()) -- 信号
        log.info("SIM", misc.getSimStatus()) -- SIM卡状态
        log.info("IMSI", misc.getImsi()) -- SIM IMSI
    elseif HW == "ZL500" then
        log.info("IMEI", misc.getImei())
        log.info("NETIF", sock.netif())
        log.info("IP", sock.ip())
        log.info("MASK", sock.netmask())
        log.info("GW", sock.gw())
        log.info("DNS", sock.dns())

    else
        log.error("error hardware type")
    end

end, 1000)

-- 网络状态，4G入网LED闪烁，否则常亮
local netled, linkled

if HW == "ZL400" then
    netled = gpio.setup(13, 0) -- output
    linkled = gpio.setup(8, 0)

elseif HW == "ZL500" then
    netled = gpio.setup(33, 0) -- output
    linkled = gpio.setup(12, 0)

end
adc.init()
-- -- gpio输出测试
sys.taskInit(function()
    while true do
        while not sock.isReady() do
            netled(1)
            linkled(1)
            sys.wait(1000)
        end

        netled(0)
        linkled(1)
        sys.wait(1000)
        netled(1)
        linkled(0)
        sys.wait(1000)

        print("adc1", adc.read(1))
        print("adc2", adc.read(2))
    end

end)

while true do sys.eventloop() end

