PROJECT = "GPIO"
VERSION = "1.0.0"

VER = ""
if rtos.hw then VER = rtos.hw():upper() end

log.warn("IMEI:", misc.getImei(), "Dev", VER)

if VER == "ZL500" or VER == "ZL400" then
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())
end

local netled, linkled

-- gpio输出测试
sys.taskInit(function()
    -- gpio13配置为输出模式
    -- gpio8配置为输出模式

    if VER == "ZL500" then
        netled = gpio.setup(33, 0) -- output
        linkled = gpio.setup(12, 0)
    else
        netled = gpio.setup(13, 0) -- output
        linkled = gpio.setup(8, 0)
    end

    log.info("test gpio", "start")
    sys.wait(1000)
    while 1 do
        netled(0)
        linkled(1)
        sys.wait(1000)
        netled(1)
        linkled(0)
        sys.wait(1000)
    end
end)

-- GPIO8配置为输入，可通过getGpio8Fnc获取输入电平
-- 请注释掉上面的gpio8输出测试
-- local getGpio8Fnc = gpio.setup(8)
-- sys.timerLoopStart(function() log.info("test gpio input", getGpio8Fnc()) end,
--                    1000)

--  gpio.setup(pin, mode, pull, irq)
--  pin 针脚编号,数字
--  mode 输入输出模式，0/1代表输出模式, nil代表输入模式, function代表中断
--  pull 暂时不支持
--  irq 中断触发模式，默认gpio.BOTH, 上升沿gpio.RISING, 下降沿gpio.FALLING， 上升和下降都要gpio.BOTH

-- function gpio8IntHandle(pin, val) log.info("test gpio int", pin, val) end

-- -- GPIO8配置为中断，可通过getGpio8Fnc()获取输入电平，产生中断时，自动执行gpio8IntHandle函数
-- getGpio8Fnc = gpio.setup(8, gpio8IntHandle)

-- 用户代码已结束---------------------------------------------
-- 结尾总是这一句
while true do sys.eventloop() end

