PROJECT = "HTTP"
VERSION = "1.0.0"

BSP = misc.getType():upper() -- 硬件类型,具体到模组型号,ZL401
HW = rtos.hw():upper()       -- 硬件类型,具体到系列型号，ZL400,ZL500

log.info("HW PLAT IS", HW)

-- 定时打印信息
sys.timerLoopStart(function()
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())

    log.info("BSP", BSP)
    log.info("TS", os.time() * 1000)

    if HW == "ZL400" then
        log.info("IMEI", misc.getImei())     -- 模组IMEI
        log.info("ICCID", misc.getIccid())   -- SIM 卡ICCID
        log.info("CSQ", misc.getCsq())       -- 信号
        log.info("SIM", misc.getSimStatus()) -- SIM卡状态
        log.info("IMSI", misc.getImsi())     -- SIM IMSI
    elseif HW == "ZL500" then
        log.info("IMEI", misc.getImei())
        log.info("NETIF", sock.netif())
        log.info("IP", sock.ip())
        log.info("MASK", sock.netmask())
        log.info("GW", sock.gw())
        log.info("DNS", sock.dns())
    else
        log.error("error hardware type")
    end
end, 1000)

-- 网络状态，4G入网LED闪烁，否则常亮
local netled, linkled

if HW == "ZL400" then
    netled = gpio.setup(13, 0) -- output
    linkled = gpio.setup(8, 0)
elseif HW == "ZL500" then
    netled = gpio.setup(33, 0) -- output
    linkled = gpio.setup(12, 0)
end

-- -- gpio输出测试
sys.taskInit(function()
    while true do
        while not sock.isReady() do
            netled(1)
            linkled(1)
            sys.wait(1000)
        end

        netled(0)
        linkled(1)
        sys.wait(1000)
        netled(1)
        linkled(0)
        sys.wait(1000)
    end
end)

local utils = require "utils"

sys.taskInit(function()
    -- 等待联网成功
    while true do
        while true do
            while not sock.isReady() do sys.wait(200) end

            local respHandler = function(ret, code, headers, body)
                -- body
                log.debug("HTTP recv over", id, code, ret)
                sys.publish("HTTP_OVER")
            end

            log.info("test http get")
            ----------------------------
            -- local param = {
            --     timeout = 15, -- 单位秒
            --     body = nil,   -- get没有body
            --     type = 1      -- body参数类型，1表单，2json
            -- }
            -- http.get("http://www.baidu.com", param, respHandler)

            -- -- 同步等待
            -- sys.waitUntil("HTTP_OVER", 10000)
            -- sys.wait(5000)
            -- ----------------------------
            -- ----------------------------
            -- param = {
            --     timeout = 15 -- 单位秒
            -- }
            -- log.info("test http get2 with url query")
            -- local url = "https://www.baidu.com"
            -- http.req("GET", url, param, respHandler)
            -- -- 同步等待
            -- sys.waitUntil("HTTP_OVER", 10000)
            -- sys.wait(5000)
            -- ----------------------------
            -- ----------------------------
            -- ----------------------------
            -- log.info("test http post")
            -- url = "https://www.baidu.com"
            -- param = {
            --     timeout = 15,                                      -- 单位秒
            --     body = json.encode({ test = 123, aa = "wqfwqf" }), -- post才有body
            --     type = 2                                           -- body参数类型，1表单，2json
            -- }
            -- http.req("POST", url, param, respHandler)
            -- sys.wait(5000)
            -- ----------------------------
            -- ----------------------------
            -- ----------------------------
            --带header参数
            local header = table.setHeader({ Authorization = "test1234" }) --table.setHeader需要require一下utils
            local name = misc.getImei()

            http.get("http://api.heclouds.com/mqtt/v1/devices/" .. name, {
                timeout = 10,
                header = header
            }, function(ret, code, headers, body)
                sys.publish("ONE_HTTP1", code, headers, body)
            end)
            local ret, code, head, body = sys.waitUntil("ONE_HTTP1", 10000)

            
            if tonumber(code) == 200 and body then
                local dat, res, err = json.decode(body)
                if res and tonumber(dat.code_no) == 0 then
                    log.info("返回的MQTTS设备:", dat.data.name)
                    sys.wait(5000)
                    return dat.data
                else
                    log.error("设备不存在:", body)
                end
            end
        end
        sys.wait(5000)
    end
end)

-- 用户代码已结束---------------------------------------------
-- 结尾总是这一句
while true do sys.eventloop() end
