PROJECT = "NET"
VERSION = "1.0.0"

BSP = misc.getType():upper() -- 硬件类型,具体到模组型号,ZL401
HW = rtos.hw():upper() -- 硬件类型,具体到系列型号，ZL400,ZL500

log.info("HW PLAT IS", HW)
log.info("IMEI IS", misc.getImei())
-- 网络状态，4G入网LED闪烁，否则常亮
if HW == "ZL400" then
    netled = gpio.setup(13, 0) -- output
    linkled = gpio.setup(8, 0)
elseif HW == "ZL500" then
    netled = gpio.setup(33, 0) -- output
    linkled = gpio.setup(12, 0)
end

-- 连上了服务器link再亮
linkled(0)

sys.taskInit(function()
    -- log.info("waut until", sys.waitUntil("IP_READY", 20000))
    while true do
        while not sock.isReady() do
            netled(0)
            sys.wait(200)
            netled(1)
            sys.wait(200)
        end

        netled(1)
        sys.wait(1000)
        log.info("net is reg")
    end
end)

sys.timerLoopStart(function()
    -- 打印基站信息
    local res, ccell, ncell = misc.getCellInfo()
    for key, value in pairs(ccell) do log.info("cell info", key, value) end
    for index, value in ipairs(ncell) do
        log.info("neibor cell info", index, json.encode(value))
    end
end, 5000)

-- 用户代码已结束---------------------------------------------
-- 结尾总是这一句
while true do sys.eventloop() end

