PROJECT = "STRING"
VERSION = "1.0.0"

log.info("pcak.pack test out")

local temp = pack.pack(">H", 0x3234)
log.info(string.toHex(temp))

temp = pack.pack("<H", 0x3234)
log.info(temp:toHex())

-- 字符串，无符号短整型，字节型，打包成二进制字符串。由于二进制不能输出，所以转化为十六进制输出。
log.info(string.toHex(pack.pack(">AHb", "xxx", 100, 10)))

log.info("pack.unpack test:")
local stringtest = pack.pack(">AHb", "l11341", 999, 10)

-- "nextpos"解析开始的位置，解析出来的第一个值val1，第二个val2，第三个val3，根据后面的格式解析
-- 这里的字符串要截取出来，如果截取字符串，后面的短整型和一个字节的数都会被覆盖。
nextpox1, val1, val2 = pack.unpack(string.sub(stringtest, 5, -1), ">Hb")

-- nextpox1表示解包后最后的位置，如果包的长度是3，nextpox1输出就是4。匹配输出999,10
log.info(nextpox1, val1, val2)

log.info("stringtest:")

log.info(string.char(97, 98, 99)) -- 将相应的数值转化为字符
log.info(string.byte("abc"), 2) -- 第一个参数是字符串，第二个参数是位置。功能是：将字符串中所给定的位置转化为数值

local i = 100
local string1 = "21sa25fsf"
log.info("string.format", string.format("%04d//%s", i, string1)) --[[指示符后的控制格式的字符可以为：十进制'd'；十六进制'x'
        八进制'o'；浮点数'f'；字符串's',控制格式的个数与后面的参数个数一致。功能：按照特定格式输出参数。--]]

log.info("string.gsub", string.gsub("my heart", "my", "your")) -- 第一个参数是目标字符串，第二个参数是标准字符串，第三个是待替换字符串

-- 打印出目标字符串在查找字符串中的首尾位置
log.info("string.find", string.find(string1, "sa"))

-- 匹配字符串,加()指的是返回指定格式的字符串,截取字符串中的数字
log.info("string.match", string.match(string1, "21sa(%d+)fsf"))

-- 截取字符串，第二个参数是截取的起始位置，第三个是终止位置。
log.info("string.sub", string.sub(string1, 1, 4))

temp = "222323535"
local hextemp = string.fromHex(temp) -- temp:fromHex()
log.info("string.fromHex", hextemp, hextemp:toHex())

-- 用户代码已结束---------------------------------------------
-- 结尾总是这一句
while true do sys.eventloop() end

