PROJECT = "SDRTU"
VERSION = "1.0.1"

-- 系统变量
VER = ""
if rtos.hw then VER = rtos.hw():upper() end
log.warn("IMEI:", misc.getImei(), "Dev", VER)
if VER == "ZL500" or VER == "ZL400" then
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())
end


--时间
log.info("timestamp", os.time())
log.info("time format", os.date("%Y-%m-%d %H:%M:%S", os.time()))

----------------------------
----------------------------
--------日志
----------------------------
----------------------------
-- #define RTU_LOG_DEBUG 1
-- #define RTU_LOG_INFO 2
-- #define RTU_LOG_WARN 3
-- #define RTU_LOG_ERROR 4
-- #define RTU_LOG_CLOSE 7
log.setLevel(1) -- 只打印 >= 对应等级的数据

log.debug("test debug log out")
log.info("test info log out")
log.warn("test warn log out")
log.error("test error log out")

----------------------------
----------------------------
--------基本计算功能演示
----------------------------
----------------------------
-- 数据类型： 数组
local testarry = { 1, 2, 3, 4, 5, 6, 7 } -- lua数组，下标是从1开始
log.info("testarry[1]=", testarry[1], testarry) -- testarry是个table

-- 数组的遍历
for index, value in ipairs(testarry) do
    log.info("数组的遍历 index value:", index, value) -- testarry是个table
end

-- 数据类型：表
local testarry = { a1 = 123, b2 = 345 } -- lua数组，下标是从1开始
log.info("testarry[1]=", testarry[a1], testarry.b2) -- 两种访问方式

-- 表的遍历
for key, value in pairs(testarry) do
    log.info("表的遍历 key value:", key, value) -- testarry是个table
end
--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
local test1 = 8765
local test2 = 1234
log.info("test1=" .. test1 .. " test2=" .. test2)

-- 数值计算
log.info("test1+test2=", test1 + test2)
log.info("test1-test2=", test1 - test2)
log.info("test1*test2=", test1 * test2)
log.info("test1/test2=", test1 / test2) -- 小数除法
log.info("test1//test2=", test1 // test2) -- 整数除法，取整等于c语言整数除法
log.info("test1%test2=", test1 % test2) -- 取余
log.info("test1^test2=", test1 ^ test2) -- 求幂 = math.pow(test1,test1)

-- 按位计算
test1 = 0x43210
test2 = 0x41234
log.info("test1=" .. test1 .. " test2=" .. test2)
log.info("test1 & test2=", test1 & test2) -- 按位与
log.info("test1 | test2=", test1 | test2) -- 按位或
log.info("test1 ~ test2=", test1 ~ test2) -- 按位异或  注意异或比较特别
log.info("1<<5 = ", 1 << 5) -- 左移
log.info("test1 >> 2 = ", test1 >> 2) -- 右移
log.info("~test1", ~test1) -- 按位非，取反；注意和异或是一样的符号

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
-- json 解压缩
-- 压缩，输入table，输出字符串
local testjson = json.encode({
    data = "rrpc,getimei,168228129166144\r\n",
    a = 12,
    b = 14.5
})

log.warn("cjson encode test", testjson)

-- 解压缩
testjson = json.decode(
"{\"sites\":[{\"name\":\"13213\",\"url\":\"www.runoob.com\"},{\"name\":2,\"url\":\"www.google.com\"},{\"name\":3.55,\"url\":\"www.weibo.com\"}]}")

log.warn("cjson decode test", testjson) -- 输出是table

-- math函数
-- math.abs (x)
-- 返回x和之间的最大值-x。（整数/浮点数）

-- math.acos (x)
-- 返回x（以弧度为单位）的反余弦值。

-- math.asin (x)
-- 返回x（以弧度为单位）的反正弦。

-- math.atan (y [, x])
-- 返回y/x（以弧度为单位）的反正切，但使用两个参数的符号来查找结果的象限。它还可以正确处理x为零的情况。

-- 的默认值为x1，以便调用math.atan(y) 返回 的反正切y。

-- math.ceil (x)
-- 返回大于或等于 的最小整数值x。

-- math.cos (x)
-- 返回x（假设为弧度）的余弦值。

-- math.deg (x)
-- 将角度x从弧度转换为度数。

-- math.exp (x)
-- 返回值e x （其中e是自然对数的底数）。

-- math.floor (x)
-- 返回小于或等于 的最大整数值x。

-- math.fmod (x, y)
-- 返回的除法的余数x由y 该轮向零商。（整数/浮点数）

-- math.huge
-- 浮点值HUGE_VAL，一个大于任何其他数值的值。

-- math.log (x [, base])
-- 返回x给定底数的对数。默认base是Ë （这样的函数返回的自然对数x）。

-- math.max (x, ···)
-- 根据 Lua operator 返回具有最大值的参数<。

-- math.maxinteger
-- 具有整数最大值的整数。
-- math.min (x, ···)
-- 根据 Lua operator 返回具有最小值的参数<。

-- math.mininteger
-- 具有整数最小值的整数。
-- math.modf (x)
-- 返回 的整数部分x和小数部分x。它的第二个结果总是一个浮点数。

-- math.pi
-- π 的值。

-- math.rad (x)
-- 将角度x从度数转换为弧度。

-- math.random ([m [, n]])
-- 当不带参数调用时，返回一个在[0,1)范围内均匀分布的伪随机浮点数 。当用两个整数mand调用时n， math.random返回一个在[m, n]范围内均匀分布的伪随机整数。math.random(n)对于正数n，调用等效于math.random(1,n)。该调用math.random(0)生成一个所有位（伪）随机的整数。

-- 此函数使用该xoshiro256**算法生成伪随机 64 位整数，这些整数是参数为 0 的调用结果。其他结果（范围和浮点数）从这些整数中无偏提取。

-- Lua 初始化其伪随机生成器，相当于调用不math.randomseed带参数的 ，因此math.random每次程序运行时应该生成不同的结果序列。

-- math.randomseed ([x [, y]])
-- 当使用至少一个参数调用时，整数参数x和y连接到一个 128 位的种子中，用于重新初始化伪随机生成器；相等的种子产生相等的数字序列。的默认值y为零。

-- 当不带参数调用时，Lua 会生成一个随机性较弱的种子。

-- 此函数返回有效使用的两个种子组件，以便再次设置它们会重复序列。

-- 为了确保初始状态所需的随机性级别（或者相反，具有确定性序列，例如在调试程序时），您应该math.randomseed使用显式参数调用。

-- math.sin (x)
-- 返回x（假定为弧度）的正弦值。

-- math.sqrt (x)
-- 返回 的平方根x。（您也可以使用表达式x^0.5来计算此值。）

-- math.tan (x)
-- 返回x（假定为弧度）的切线。

-- math.tointeger (x)
-- 如果该值x可转换为整数，则返回该整数。否则，返回失败。

-- math.type (x)
-- 返回“ integer”如果x是一个整数，“ float”如果它是一个浮动，或失败，如果x不是数字。

-- math.ult (m, n)
-- 返回一个布尔值，当且仅当它们作为无符号整数进行比较时整数m小于整数n时才为真。

----------------------------
----------------------------
--------基本接口，定时器
----------------------------
----------------------------

-- 单次定时调用, 入参：callbackfun,  time, contx_a, contx_b, contx_c
-- 定时单位是ms，误差小于10ms
-- sys.timerStart(fun(a,b,c), time, a,b,c)

-- 测量tick的时间
local tickstart = rtos.tick() -- 单位是ms
sys.timerStart(function(a, b, c)
    endt = rtos.tick()
    log.warn("5s period tick  is", (endt - tickstart), a, b, c)
end, 5000, "aa", "vv", 55)

-- 周期定时调用, 入参：callbackfun,  time, contx_a, contx_b, contx_c
-- 定时单位是ms，误差小于10ms
-- sys.timerLoopStart(fun(a,b,c), time, a,b,c)
sys.timerLoopStart(function(a, b, c)
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())
    log.info("contex", a, b, c)
end, 15000, "aa", "bb", 12354)

----------------------------
----------------------------
--------基本接口，协程创建
----------------------------
----------------------------

-- 创建协程,入参：fun, contx_a, contx_b, contx_c
-- sys.taskInit(fun, a, b, c)
local taskcnt = 0

local taskHandle = function(a, b, c)
    log.debug("taskHandle contex", a, b, c) -- 打印可变参数
    -- log.debug(arg[1]) -- 打印可变参数
    -- body
    while true do -- 协程内部可以做成while(1) 记得加wait延迟，不要100%占用cpu
        sys.wait(1000) -- 延迟1000ms, 必须在协程内部使用
        taskcnt = taskcnt + 1
        if taskcnt == 15 then
            log.warn("taskInit test2", taskcnt, a, b, c)
        end
    end
end
log.warn("taskInit test1", taskcnt)
sys.taskInit(taskHandle, 1, 2, "3333")

----------------------------
----------------------------
--------基本接口，高性能消息总线
----------------------------
----------------------------
-- 发布消息
-- @string topic, 订阅的目标主题
-- @param msg1 各种类型的数据
-- sys.publish(topic, msg1, msg2, msg3)

-- 对应的订阅接口
-- @string topic, 订阅的目标主题
-- @param handle, 为function时，调用回调函数；为string时为数据转发到to目标主题
-- sys.subscribe(topic, [handle | nextTopic])

--- 取消订阅消息
-- @param id 消息topic
-- @param callback 消息回调处理，function, string
-- @usage unsubscribe("NET_STATUS", callback)
-- sys.unsubscribe(topic, callback)
-- sys.unsubscribeAll(topic)

-- 启动消息总线，需要启动后，消息才能处理
-- while true do sys.eventloop() end

-- 使用实例
-- 基本发布订阅使用
local sendTopic = "NET_SEND_1"
local recvTopic = "NET_RECV_1"

local function handle(msg) log.info("test publish msg to recvTopic", msg) end

sys.subscribe(recvTopic, handle)
sys.publish(recvTopic, "12344")
-- 运行后打印1234

------------------------------------
-- 带消息来源的使用
local function handle1(msg, id, from) log.info("msg1", msg) end

local function handle2(msg, id, from) log.info("msg2", msg) end

local hanleTab = { ["UART_RECV_1"] = handle1, ["UART_RECV_2"] = handle2 }

local function ruleWorker(data, id, from)
    local callback = hanleTab[from]
    if callback and data then callback(data) end
end

sys.subscribe("NET_SEND_7", ruleWorker)

-- 模拟串口发送到规则通道
sys.publish("NET_SEND_7", "12344", 1, "UART_RECV_1")
sys.publish("NET_SEND_7", "12344", 2, "UART_RECV_2")

------------------------------------
-- 消息转发的使用
local function handle1(msg, id, from)
    log.info("publish msg from NET_SEND_8 to NET_SEND_1", msg)
end

sys.subscribe("NET_SEND_1", handle1)
sys.subscribe("NET_SEND_8", "NET_SEND_1")
-- 发送消息到通道8，流转到通道1
sys.publish("NET_SEND_8", "12344", 2, "UART_RECV_2")

-- 测试消息队列
timerCn = 0
sys.testsubfun = function(...)
    timerCnt = timerCnt + 1
    if timerCnt >= 100 then
        log.warn("msg test1 tick")
        -- test unsubscribe
        sys.unsubscribe("testtopic", sys.testsubfun)
    end
end
sys.subscribe("testtopic", sys.testsubfun)

-- 连续发一百条消息
for i = 1, 100 do sys.publish("testtopic", i) end

----------------------------------
----------------------------------
----------------------------------
-- 协程调度测试，生产消费模型
log.info("start coroutine perf test2, conusmer test with 200 cycle")
local start3 = rtos.tick()
timerCnt = 0
sys.taskInit(function(...)
    -- body
    while true do
        sys.waitUntil("utest1", 20000) -- 和wait不同，从消息队列取消息，收到了立即结束。否则等到超时，单位ms
        timerCnt = timerCnt + 1
        if timerCnt == 200 then
            endt = rtos.tick()
            log.warn("coroutine test2 tick", endt - start3)
            return
        end
        sys.publish("utest2", "i1", rtos.tick())
    end
end)

sys.taskInit(function(...)
    -- body
    while true do
        sys.waitUntil("utest2", 20000) -- 和wait不同，从消息队列取消息，收到了立即结束。否则等到超时，单位ms
        timerCnt = timerCnt + 1
        if timerCnt == 200 then
            endt = rtos.tick()
            log.warn("coroutine test2 tick", endt - start3)
            return
        end
        sys.publish("utest1", "i1", rtos.tick())
    end
end)

-- 启动测试
sys.publish("utest1", "i1", rtos.tick()) -- 启动测试

log.info("mem sys", rtos.meminfo("sys"))
log.info("mem lua", rtos.meminfo())

-- 启动消息总线
while true do sys.eventloop() end
