-- PROJECT = "UART"
-- VERSION = "1.0.0"
-- 模拟接收数据
sys.subscribe("UART_ECHO", function(id, data)
    log.info("test UART_ECHO", id, #data)
    if #data > 0 then uart.write(id, data) end
end)
sys.timerLoopStart(function()
    log.info("start uart test app")
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())
end, 5000)

-- uart.setup(2, 9600)
gpio.setup(13, 0)
uart.indicate(13, 13)
-- 函数原型
-- uart.setup(id, baud_rate, data_bits, partiy, stop_bits, rs485, rwait, buff_size)
--  串口id, uart1是1, uart2是2
--  波特率 1200~460800
--  数据位 7或8, 默认是8
--  校验位 uart.None/uart.Even/uart.Odd，默认无
--  停止位 1或2, 默认是1
--  RS485使能引脚，高有效，没有写0
--  rwait 接收分帧时间，单位ms,默认200
--  buff_size 缓冲区长度默认值10k字节
uart.setup(1, 9600, 8, 0, 1, 19, 20, 4096)
uart.setup(2, 9600, 8, 0, 1, 0, 20, 4096)
-- uart.close(1)
-- 修改接收分帧时间
-- uart.rwait(100)

uart.on(1, "recv", function(id, len)

    -- 读取数据
    local data = uart.read(id, len)
    log.info("test uart1 read", id, len, data)

    -- 发出去模拟处理数据
    sys.publish("UART_ECHO", id, data)
end)

uart.on(2, "recv", function(id, len)

    -- 读取数据
    local data = uart.read(id, len)
    log.info("test uart2 read", id, len, data)

    -- 发出去模拟处理数据
    sys.publish("UART_ECHO2", id, data)
end)

uart.on(1, "sent",
    function(id, len) log.info("uart data send over, len=", len) end)

misc.setPower(1)

-- 用户代码已结束---------------------------------------------
-- 结尾总是这一句
while true do sys.eventloop() end
