PROJECT = "GPIO"
VERSION = "1.0.0"

BSP = misc.getType():upper() -- 硬件类型,具体到模组型号,ZL401
HW = rtos.hw():upper() -- 硬件类型,具体到系列型号，ZL400,ZL500

log.info("HW PLAT IS", HW)

-- 定时打印信息
sys.timerStart(function()
    log.info("mem sys", rtos.meminfo("sys"))
    log.info("mem lua", rtos.meminfo())

    log.info("BSP", BSP)
    log.info("TS", os.time() * 1000)

    if HW == "ZL400" then
        log.info("IMEI", misc.getImei()) -- 模组IMEI
        log.info("ICCID", misc.getIccid()) -- SIM 卡ICCID
        log.info("CSQ", misc.getCsq()) -- 信号
        log.info("SIM", misc.getSimStatus()) -- SIM卡状态
        log.info("IMSI", misc.getImsi()) -- SIM IMSI
    elseif HW == "ZL500" then
        log.info("IMEI", misc.getImei())
        log.info("NETIF", sock.netif())
        log.info("IP", sock.ip())
        log.info("MASK", sock.netmask())
        log.info("GW", sock.gw())
        log.info("DNS", sock.dns())

    else
        log.error("error hardware type")
    end

end, 1000)

-- 网络状态，4G入网LED闪烁，否则常亮
local netled, linkled

local audioHandle = function()
    log.info("audioHandle")
    -- tts.stopAudio()
    -- tts.delAudio()
    -- restart 
    tts.playAudio("/data/test.mp3", 44100)
end

local function testMp3()
    log.info("testMp3")
    tts.playAudio("/data/test.mp3", 44100) -- 文件名，采样率,直接就是异步的
end

tts.initAudio()
sys.subscribe("AUDIO_OVER", audioHandle)

local ttsHandle = function()
    log.info("ttsHandle")
    tts.stop()
    -- testMp3()
end

local function testtts()
    -- 测试语音
    -- 初始化tts
    tts.init()
    tts.set(3, 0) -- 默认
    -- tts.vol(100) -- 音量

    tts.play("系统启动程序开始运行")
    sys.subscribe("TTS_OVER", ttsHandle)
end

sys.timerStart(function()
    -- testtts()
    testMp3()
end, 1000)

if HW == "ZL400" then
    netled = gpio.setup(13, 0) -- output
    linkled = gpio.setup(8, 0)

elseif HW == "ZL500" then
    netled = gpio.setup(33, 0) -- output
    linkled = gpio.setup(12, 0)
end

while true do sys.eventloop() end

